c78fd9000f0ae9102d620f6507d1c7fd885e05c9
[automated-distro-installer] / wrt-setup-local
1 #!/bin/bash
2 # Copyright (C) 2016 Ian Kelling
3
4 # This program is free software; you can redistribute it and/or
5 # modify it under the terms of the GNU General Public License
6 # as published by the Free Software Foundation; either version 2
7 # of the License, or (at your option) any later version.
8
9 # This program is distributed in the hope that it will be useful,
10 # but WITHOUT ANY WARRANTY; without even the implied warranty of
11 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
12 # GNU General Public License for more details.
13
14 # You should have received a copy of the GNU General Public License
15 # along with this program; if not, write to the Free Software
16 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
17
18 # shellcheck disable=SC1091 # somewhat dynamic
19
20 set -e; . /usr/local/lib/bash-bear; set +e
21
22
23 usage() {
24 cat <<EOF
25 usage: ${0##*/} [-h] [-t 2|3|test|client] [-m WIRELESS_MAC] [hostname]
26 setup my router in general: dhcp, dns, etc.
27
28 Type 2 or 3 is for setting up a backup device, there are two kinds so
29 that you can switch the main device to a backup, then a backup to the
30 main. Type test is for setting up a testing device.
31
32 Passing an empty string for WIRELESS_MAC, or if none is defined in the
33 secrets file, will cause the device's native mac to be used.
34
35 EOF
36
37 exit $1
38 }
39
40
41
42 zblock=false
43 if [[ -e /root/zblock ]]; then
44 zblock=true
45 fi
46
47 dnsmasq_restart=false
48 unbound_restart=false
49 firewall_restart=false
50 dev2=false
51 test=false
52 client=false
53 ap=false
54 libremanage_host=wrt2
55 lanip=1
56 while getopts hm:t:yz opt; do
57 case $opt in
58 h) usage 0 ;;
59 t)
60 case $2 in
61 2|3)
62 dev2=true
63 libremanage_host=$hostname
64 ;;&
65 2)
66 lanip=4
67 hostname=wrt2
68 ;;
69 3)
70 lanip=14
71 hostname=wrt3
72 ;;
73 test)
74 test=true
75 ;;
76 client)
77 client=true
78 ;;
79 ap)
80 ap=true
81 lanip=53
82 hostname=cmcap
83 ;;
84 *) echo "$0: unexpected arg to -t: $*" >&2; usage 1 ;;
85 esac
86 ;;
87 y)
88 zblock=false
89 rm -f /root/zblock
90 ;;
91 z)
92 zblock=true
93 touch /root/zblock
94 ;;
95 m) mac=$OPTARG ;;
96 *) echo "$0: Internal error! unexpected args: $*" >&2 ; usage 1 ;;
97 esac
98 done
99 shift "$((OPTIND-1))" # Discard the options and sentinel --
100
101 if [[ $1 ]]; then
102 h=$1
103 elif [[ $hostname ]]; then
104 h=$hostname
105 else
106 h=cmc
107 fi
108
109 if [[ ! $hostname ]]; then
110 hostname=$h
111 fi
112
113
114 secrets=false
115 if [[ -e /root/router-secrets ]]; then
116 secrets=true
117 # shellcheck source=/p/router-secrets
118 source /root/router-secrets
119 fi
120
121 if [[ ! $mac ]] && ! $test && $secrets; then
122 # if we wanted to increment it
123 #mac=${mac:0: -1}$((${mac: -1} + 2))
124 mac=${rwmac[$h]}
125 fi
126
127 if (( $# != 0 )); then
128 usage 1
129 fi
130
131
132 macpre=${mac:0: -1}
133 macsuf=${mac: -1}
134
135
136 p_updated=false
137 pmirror() {
138 if $p_updated; then
139 return
140 fi
141 # background: upgrading all packages is not recommended because it
142 # doesn't go into the firmware. build new firmware if you want
143 # lots of upgrades. I think /tmp/opkg-lists is a pre openwrt 14 location.
144 f=(/var/opkg-lists/*)
145 if ! (( $(date -r ${f[0]} +%s) + 60*60*24 > $(date +%s) )); then
146 if ! opkg update; then
147 echo "$0: warning: opkg update failed" >&2
148 fi
149 p_updated=true
150 fi
151 }
152
153 pi() {
154 to_install=()
155 for p in "$@"; do
156 pname=${p##*/}
157 pname=${pname%%_*}
158 if [[ ! $(opkg list-installed "$pname") ]]; then
159 to_install+=($p)
160 pmirror
161 fi
162 done
163 if (( ${#to_install[@]} >= 1 )); then
164 opkg install ${to_install[@]}
165 fi
166 }
167
168 v() {
169 printf "+ %s\n" "$*"
170 "$@"
171 }
172
173 ######### uci example:#######
174 # # https://wiki.openwrt.org/doc/uci
175 # wan_index=$(uci show firewall | sed -rn 's/firewall\.@zone\[([0-9])+\]\.name=wan/\1/p')
176 # wan="firewall.@zone[$wan_index]"
177 # if [[ $(uci get firewall.@forwarding[0].dest) != $forward_dest ]]; then
178 # # default is wan
179 # v uci set firewall.@forwarding[0].dest=$forward_dest
180 # uci commit firewall
181 # firewall_restart=true
182 # fi
183 ####### end uci example #####
184
185 uset() {
186 printf "+ uset %s\n" "$*"
187 local key="$1"
188 local val="$2"
189 local service="${key%%.*}"
190 restart_var=${service}_restart
191 if [[ ! ${!restart_var} ]]; then
192 eval $restart_var=false
193 fi
194 if [[ $(uci get "$key") != "$val" ]]; then
195 v uci set "$key"="$val"
196 uci commit $service
197 eval $restart_var=true
198 fi
199 }
200
201 udel() {
202 printf "+ udel %s\n" "$*"
203 local key="$1"
204 local val="$2"
205 local service="${key%%.*}"
206 restart_var=${service}_restart
207 if [[ ! ${!restart_var} ]]; then
208 eval $restart_var=false
209 fi
210 if uci get "$key" &>/dev/null; then
211 v uci set "$key"="$val"
212 uci commit $service
213 eval $restart_var=true
214 fi
215 }
216 cedit() {
217 v command cedit -v "$@"
218 }
219
220
221 ### network config
222 ###
223 lan=10.0.0.0
224 if $test; then
225 lan=10.1.0.0
226 elif [[ $hostname == cmc || $hostname == cmcap ]]; then
227 lan=10.2.0.0
228 elif $client; then
229 lan=10.3.0.0
230 fi
231
232 if $test; then
233 ssid="gnuv3"
234 elif $secrets; then
235 ssid=${rssid[$h]}
236 fi
237
238 : "${ssid:=librecmc}"
239
240
241 if $secrets; then
242 key=${rkey[$h]}
243 fi
244 : "${key:=pictionary49}"
245
246 mask=255.255.0.0
247 cidr=16
248 l=${lan%.0}
249
250 # why did we lock this? i don't know
251 #passwd -l root ||: #already locked fails
252
253 sed -ibak '/^root:/d' /etc/shadow
254 # /root/router created by manually running passwd then copying the resulting
255 # line. We have no mkpasswd on wrt/librecmc, then we scp it in.
256 cat /root/router >>/etc/shadow
257 # otherwise, serial console gets root login with no password
258 uset system.@system[0].ttylogin 1
259
260
261
262 cat >/usr/bin/archlike-pxe-mount <<'EOFOUTER'
263 #!/bin/bash
264 # symlinks are collapsed for nfs mount points, so use a bind mount.
265 # tried putting this in /etc/config/fstab,
266 # then doing block mount, it didn't work. This doesn't persist across reboots,
267 # todo: figure that out
268 rm -f /etc/fstab
269 for d in /run/{arch,parabola}iso/bootmnt; do
270 cat >>/etc/fstab <<EOF
271 /mnt/usb/tftpboot $d none bind 0 0
272 EOF
273 mount | grep $d &>/dev/null || mount $d
274 done
275 /etc/init.d/nfsd restart
276 EOFOUTER
277 chmod +x /usr/bin/archlike-pxe-mount
278
279 sed -i '/^root:/s,/bin/ash$,/bin/bash,' /etc/passwd
280
281
282
283 uset dropbear.@dropbear[0].PasswordAuth 0
284 uset dropbear.@dropbear[0].RootPasswordAuth 0
285 uset dropbear.@dropbear[0].Port 2220
286 if ! cmp -s /root/dropbear_rsa_host_key /etc/dropbear/dropbear_rsa_host_key; then
287 cp /root/dropbear_rsa_host_key /etc/dropbear/dropbear_rsa_host_key
288 dropbear_restart=true
289 fi
290
291 if $dropbear_restart; then
292 v /etc/init.d/dropbear restart
293 fi
294
295
296 uset network.lan.ipaddr $l.$lanip
297 uset network.lan.netmask $mask
298 if $dev2 || $client || $ap; then
299 if $dev2 || $ap; then
300 uset network.lan.gateway $l.1
301 uset network.wan.proto none
302 uset network.wan6.proto none
303 fi
304 /etc/init.d/dnsmasq stop
305 /etc/init.d/dnsmasq disable
306 /etc/init.d/odhcpd stop
307 /etc/init.d/odhcpd disable
308 rm -f /etc/resolv.conf
309 if $ap; then
310 cat >/etc/resolv.conf <<EOF
311 nameserver $l.1
312 EOF
313 else
314 cat >/etc/resolv.conf <<'EOF'
315 nameserver 8.8.8.8
316 nameserver 8.8.4.4
317 EOF
318 fi
319
320 # things i tried to keep dnsmasq running but not enabled except local dns,
321 # but it didnt work right and i dont need it anyways.
322 # uset dhcp.wan.ignore $dev2 # default is false
323 # uset dhcp.lan.ignore $dev2 # default is false
324 # uset dhcp.@dnsmasq[0].interface lo
325 # uset dhcp.@dnsmasq[0].localuse 0
326 # uset dhcp.@dnsmasq[0].resolvfile /etc/dnsmasq.conf
327 # uset dhcp.@dnsmasq[0].noresolv 1
328 # todo: populate /etc/resolv.conf with a static value
329
330 else
331 # these are the defaults
332
333 # this is not needed unless switching from the above condition.
334 # disabling just to debug
335 #uset network.lan.gateway ''
336
337 uset network.wan.proto dhcp
338 uset network.wan6.proto dhcpv6
339 /etc/init.d/dnsmasq start
340 # todo: figure out why this returns 1
341 /etc/init.d/dnsmasq enable ||:
342 /etc/init.d/odhcpd start
343 /etc/init.d/odhcpd enable
344 fi
345
346 wireless_restart=false
347
348 if $client; then
349 uset wireless.default_radio0.network 'wwan'
350 uset wireless.default_radio0.ssid ${rclientssid[$h]}
351 uset wireless.default_radio0.encryption 'psk2'
352 uset wireless.default_radio0.device 'radio0'
353 uset wireless.default_radio0.mode 'sta'
354 uset wireless.default_radio0.bssid ${rclientbssid[$h]}
355 # todo: look into whether 5g network is available.
356 uset wireless.default_radio0.key ${rclientkey[$h]}
357 uset wireless.radio0.disabled false
358 uset wireless.radio1.disabled true
359 else
360 # defaults, just reseting in case client config ran
361 uset wireless.default_radio0.network lan
362 uset wireless.default_radio0.mode ap
363 for x in 0 1; do
364 uset wireless.default_radio$x.ssid "$ssid"
365 uset wireless.default_radio$x.key $key
366 uset wireless.default_radio$x.encryption psk2
367 if [[ $mac ]]; then
368 uset wireless.default_radio$x.macaddr $macpre$((macsuf + 2*x))
369 fi
370 # disable/enable. secondary device has wireless disabled
371 uset wireless.radio$x.disabled $dev2
372 done
373 fi
374
375 if grep '^OPENWRT_BOARD="mvebu/cortexa9"' /etc/os-release &>/dev/null; then
376 # todo, I also enabled irqbalance, didnt script it though
377 # https://forum.openwrt.org/t/wrt1900acs-wifi-issue-after-upgrade-from-19-07-to-21-02-vacuum-cleaner-legacy-rate-support/113311/28
378 cat >/etc/rc.local <<'EOF'
379 echo "0" >> /sys/kernel/debug/ieee80211/phy0/mwlwifi/tx_amsdu
380 echo "0" >> /sys/kernel/debug/ieee80211/phy1/mwlwifi/tx_amsdu
381 exit 0
382 EOF
383 chmod +x /etc/rc.local
384 /etc/rc.local
385 uset wireless.radio0.disassoc_low_ack 0
386 uset wireless.radio1.disassoc_low_ack 0
387 fi
388
389
390 # found with https://openwrt.org/docs/guide-user/network/wifi/iwchan.
391 # However, the default also chooses 11, and better to let it choose in case things change.
392 # case $HOSTNAME in
393 # cmc)
394 # uset wireless.radio0.channel 11
395 # ;;
396 # esac
397
398
399 # usb, screen, relay are for libremanage
400 # rsync is for brc
401 #
402 # relay package temporarily disabled
403 # /root/relay_1.0-1_mips_24kc.ipk
404 #
405 # note: prometheus-node-exporter-lua-openwrt seems to be a dependency of
406 # prometheus-node-exporter-lua in practice.
407
408 pkgs=(
409 tcpdump
410 screen
411 rsync
412 kmod-usb-storage
413 block-mount
414 kmod-fs-ext4
415 prometheus-node-exporter-lua-openwrt
416 prometheus-node-exporter-lua
417 )
418
419 if ! $ap; then
420 pkgs+=(
421 unbound-daemon
422 unbound-checkconf
423 )
424 fi
425
426 v pi "${pkgs[@]}"
427 # nfs-kernel-server \
428 # openvpn-openssl adblock libusb-compat \
429 # kmod-usb-serial-cp210x kmod-usb-serial-ftdi \
430
431
432 cat >/etc/libremanage.conf <<EOF
433 ${libremanage_host}_type=switch
434 ${libremanage_host}_channel=1
435 EOF
436
437
438
439 v /etc/init.d/fstab enable ||:
440
441 # rebooting makes mounting work, but comparing lsmod,
442 # i'm guessing this will too. todo, test it.
443 # 255 == module already loaded
444 for mod in scsi_mod sd_mod; do v modprobe $mod || [[ $? == 255 ]]; done
445
446 # for archlike pxe. The default settings in the installer expect to find
447 # the NFS at one of these dirs
448 mkdir -p /run/archiso/bootmnt
449 mkdir -p /run/parabolaiso/bootmnt
450
451 # todo: at some later time, i found /mnt/usb not mounted, watch to see if
452 # that is the case after running this or rebooting.
453 # wiki says safe to do in case of fstab changes:
454
455 ## ian: usb broke on old router. if that happens, can just comment this to disable problems
456 # echo | cedit /etc/config/fstab ||:
457 cedit /etc/config/fstab <<EOF || { v block umount; v block mount; }
458 config global automount
459 option from_fstab 1
460 option anon_mount 1
461
462 config mount
463 # /overlay is an / overlay mount for installing extra packages, etc.
464 # https://openwrt.org/docs/guide-user/additional-software/extroot_configuration
465 option target /mnt/usb
466 # option target /overlay
467 option device /dev/sda1
468 option fstype ext4
469 option options rw,async,noatime,nodiratime
470 option enabled 0
471 EOF
472
473
474 # ian: disabled because afaik I don't need it, no benefit.
475 # config global autoswap
476 # option from_fstab 1
477 # option anon_swap 1
478
479 # config swap
480 # option device /dev/sda1
481 # option enabled 1
482
483
484
485
486 # exportfs -ra wont cut it when its the same path, but now a bind mount
487 # todo: restart nfs when nfs is enabled?
488 #cedit /etc/exports <<EOF || v /etc/init.d/nfsd restart ||:
489 cedit /etc/exports <<EOF ||:
490 /mnt/usb $lan/$cidr(rw,no_root_squash,insecure,sync,no_subtree_check)
491 # for arch pxe
492 /run/archiso/bootmnt $lan/$cidr(rw,no_root_squash,insecure,sync,no_subtree_check)
493 /run/parabolaiso/bootmnt $lan/$cidr(rw,no_root_squash,insecure,sync,no_subtree_check)
494 EOF
495
496
497 # todo: enable nfs when we need it only.
498 # v /etc/init.d/portmap start
499 # v /etc/init.d/nfsd start
500 # v /etc/init.d/portmap enable
501 # v /etc/init.d/nfsd enable
502
503
504 cedit /etc/config/prometheus-node-exporter-lua <<'EOF' || /etc/init.d/prometheus-node-exporter-lua restart
505 config prometheus-node-exporter-lua 'main'
506 option listen_ipv6 '0'
507 option listen_interface 'lan'
508 option listen_port '9100
509 EOF
510
511 # default, as of this writing is:
512 # config prometheus-node-exporter-lua 'main'
513 # option listen_interface 'loopback'
514 # option listen_port '9100'
515
516
517
518
519
520 ########## openvpn exampl
521 ########## missing firewall settings for routing lan
522 ########## traffic
523 # v /etc/init.d/openvpn start
524 # v /etc/init.d/openvpn enable
525
526 # # from https://wiki.openwrt.org/doc/uci/firewall
527 # # todo: not sure if /etc/init.d/network needs restarting.
528 # # I did, and I had to restart the vpn afterwards.
529 # # This maps a uci interface to a real interface which is
530 # # managed outside of uci.
531 # cedit /etc/config/network <<'EOF' ||:
532 # config interface 'tun0'
533 # option ifname 'tun0'
534 # option proto 'none'
535 # EOF
536 # cedit /etc/config/openvpn <<'EOF' || v /etc/init.d/openvpn restart
537 # config openvpn my_client_config
538 # option enabled 1
539 # option config /etc/openvpn/client.conf
540 # EOF
541
542
543 wgport=26000
544
545 network_restart=false
546 if $client; then
547 cedit wific /etc/config/network <<EOF || network_restart=true
548 # https://openwrt.org/docs/guide-user/network/wifi/connect_client_wifi
549 config interface 'wwan'
550 option proto 'dhcp'
551 EOF
552 fi
553
554 cedit /etc/config/network <<EOF || network_restart=true
555 config 'route' 'transmission'
556 option 'interface' 'lan'
557 option 'target' '10.174.0.0'
558 option 'netmask' '255.255.0.0'
559 option 'gateway' '$l.2'
560
561 option interface 'wg0'
562 option proto 'wireguard'
563 option private_key '$(cat /root/wg.key)'
564 option listen_port $wgport
565 list addresses '10.3.0.1/24'
566 list addresses 'fdfd::1/64'
567
568 # tp
569 config wireguard_wg0 'wgclient'
570 option public_key '3q+WJGrm85r59NgeXOIvppxoW4ux/+koSw6Fee1c1TI='
571 option preshared_key '$(cat /root/wg.psk)'
572 list allowed_ips '10.3.0.2/24'
573 list allowed_ips 'fdfd::2/64'
574 EOF
575
576 # Need to reload before we change dnsmasq to give out
577 # static ips in our new range.
578 if $network_restart; then
579 v /etc/init.d/network reload
580 fi
581
582
583 ### begin firewall edits ###
584 if $client; then
585 cedit wific /etc/config/firewall <<EOF || firewall_restart=true
586 config zone
587 option name wwan
588 option input REJECT
589 option output ACCEPT
590 option forward REJECT
591 option masq 1
592 option mtu_fix 1
593 option network wwan
594 EOF
595 fi
596
597 case $hostname in
598 wrt)
599 cedit host /etc/config/firewall <<EOF || firewall_restart=true
600 config redirect
601 option name ssh
602 option src wan
603 option src_dport 22
604 option dest_ip $l.3
605 option dest lan
606 EOF
607 ;;
608 cmc)
609 cedit host /etc/config/firewall <<EOF || firewall_restart=true
610 config redirect
611 option name ssh
612 option src wan
613 option src_dport 22
614 option dest_ip $l.2
615 option dest lan
616 EOF
617 ;;
618 esac
619
620 {
621 # shellcheck source=/p/c/cmc-firewall-data
622 . /root/cmc-firewall-data
623 cat <<EOF
624 ## begin no external dns for ziva
625 config rule
626 option src lan
627 option src_ip 10.2.0.23
628 option dest_port 53
629 option dest wan
630 option target REJECT
631
632
633 config rule
634 option src wan
635 option dest_ip 10.2.0.23
636 option src_port 53
637 option dest lan
638 option target REJECT
639
640
641 config rule
642 option src lan
643 option src_ip 10.2.0.31
644 option dest_port 53
645 option dest wan
646 option target REJECT
647
648
649 config rule
650 option src wan
651 option dest_ip 10.2.0.31
652 option src_port 53
653 option dest lan
654 option target REJECT
655
656
657 config rule
658 option src lan
659 option src_ip 10.2.0.32
660 option dest_port 53
661 option dest wan
662 option target REJECT
663
664
665 config rule
666 option src wan
667 option dest_ip 10.2.0.32
668 option src_port 53
669 option dest lan
670 option target REJECT
671 ## end no external dns for ziva
672
673
674 config rule
675 option src wan
676 option target ACCEPT
677 option dest_port 22
678
679 config redirect
680 option name promkd
681 option src wan
682 option src_dport 9091
683 option dest_port 9091
684 option dest_ip $l.2
685 option dest lan
686 config rule
687 option src wan
688 option target ACCEPT
689 option dest_port 9091
690
691 # was working on an openvpn server, didn't finish
692 # config redirect
693 # option name vpnkd
694 # option src wan
695 # option src_dport 1196
696 # option dest_port 1196
697 # option dest_ip $l.2
698 # option dest lan
699 # config rule
700 # option src wan
701 # option target ACCEPT
702 # option dest_port 1196
703
704
705 config redirect
706 option name sshkdalt
707 option src wan
708 option src_dport 8989
709 option dest_port 8989
710 option dest_ip $l.2
711 option dest lan
712 config rule
713 option src wan
714 option target ACCEPT
715 option dest_port 8989
716
717
718
719 config redirect
720 option name icecast
721 option src wan
722 option src_dport 8000
723 option dest_port 8000
724 option dest_ip $l.2
725 option dest lan
726 config rule
727 option src wan
728 option target ACCEPT
729 option dest_port 8000
730
731 config rule
732 option name sshcmc
733 option src wan
734 option target ACCEPT
735 option dest_port 2220
736
737 config rule
738 option name wg
739 option src wan
740 option target ACCEPT
741 option dest_port $wgport
742 option proto udp
743
744 config redirect
745 option name navidromehttps
746 option src wan
747 option src_dport 4500
748 option dest_port 4500
749 option dest_ip $l.2
750 option dest lan
751 config rule
752 option src wan
753 option target ACCEPT
754 option dest_port 4500
755
756 config redirect
757 option name navidrome
758 option src wan
759 option src_dport 4533
760 option dest_port 4533
761 option dest_ip $l.2
762 option dest lan
763 config rule
764 option src wan
765 option target ACCEPT
766 option dest_port 4533
767
768 # So a client can just have b8.nz dns even when they
769 # are on the lan.
770 #config redirect
771 # option name navidromelan
772 # option src lan
773 # option src_dport 4533
774 # option dest_port 4533
775 # option dest_ip $l.2
776 # option dest lan
777
778
779 # config redirect
780 # option name icecast
781 # option src wan
782 # option src_dport 8000
783 # option dest_port 8000
784 # option dest_ip $l.2
785 # option dest lan
786 # config rule
787 # option src wan
788 # option target ACCEPT
789 # option dest_port 8000
790
791 config redirect
792 option name http
793 option src wan
794 option src_dport 80
795 option dest lan
796 option dest_ip $l.3
797 option proto tcp
798 config rule
799 option src wan
800 option target ACCEPT
801 option dest_port 80
802 option proto tcp
803
804 config redirect
805 option name https
806 option src wan
807 option src_dport 443
808 option dest lan
809 option dest_ip $l.3
810 option proto tcp
811 config rule
812 option src wan
813 option target ACCEPT
814 option dest_port 443
815 option proto tcp
816
817 # config redirect
818 # option name httpskd8448
819 # option src wan
820 # option src_dport 8448
821 # option dest lan
822 # option dest_ip $l.2
823 # option proto tcp
824 # config rule
825 # option src wan
826 # option target ACCEPT
827 # option dest_port 8448
828 # option proto tcp
829
830 config redirect
831 option name syncthing
832 option src wan
833 option src_dport 22001
834 option dest_ip $l.8
835 option dest lan
836 config rule
837 option src wan
838 option target ACCEPT
839 option dest_port 22001
840
841
842 #config redirect
843 # option name i2p
844 # option src wan
845 # option src_dport $i2pport
846 # option dest_ip $l.178
847 # option dest lan
848 #config rule
849 # option src wan
850 # option target ACCEPT
851 # option dest_port $i2pport
852
853 config rule
854 option name ssh-ipv6
855 option src wan
856 option dest lan
857 # note, using mac transform, we could allow all traffic to a host like this,
858 # replacing 1 as appropriate
859 #option dest_ip ::111:11ff:fe11:1111/::ffff:ffff:ffff:ffff
860 option dest_port 22
861 option target ACCEPT
862 option family ipv6
863
864 # config rule
865 # option name http-ipv6
866 # option src wan
867 # option dest lan
868 # option dest_port 80
869 # option target ACCEPT
870 # option family ipv6
871
872 # config rule
873 # option name https-ipv6
874 # option src wan
875 # option dest lan
876 # option dest_port 443
877 # option target ACCEPT
878 # option family ipv6
879
880 config rule
881 option name node-exporter
882 option src wan
883 option dest lan
884 option dest_port 9101
885 option target ACCEPT
886 option family ipv6
887
888 config rule
889 option name mail587-ipv6
890 option src wan
891 option dest lan
892 option dest_port 587
893 option target ACCEPT
894 option family ipv6
895
896 EOF
897 } | cedit /etc/config/firewall || firewall_restart=true
898 ### end firewall edits ###
899
900
901 # firewall comment:
902 # not using and in newer wrt, fails, probably due to nonexistent file, error output
903 # on:
904
905 # Reference error: left-hand side expression is not an array or object
906 # In [anonymous function](), file /usr/share/ucode/fw4.uc, line 3137, byte 12:
907 # called from function [arrow function] (/usr/share/ucode/fw4.uc:733:71)
908 # called from function foreach ([C])
909 # called from function [anonymous function] (/usr/share/ucode/fw4.uc:733:72)
910 # called from function render_ruleset (/usr/share/firewall4/main.uc:56:24)
911 # called from anonymous function (/usr/share/firewall4/main.uc:143:29)
912 #
913 # ` if (!inc.enabled) {`
914 # Near here -------^
915 #
916 #
917 # The rendered ruleset contains errors, not doing firewall restart.
918 # /usr/bin/wrt-setup-local:160:error: ""$@"" returned 1
919
920 ## include a file with users custom iptables rules
921 #config include
922 # option path /etc/firewall.user
923 # option type 'restore'
924 # option family 'ipv4'
925
926
927
928 # not using wireguard for now
929 # if ! uci get firewall.@zone[1].network | grep wg0 &>/dev/null; then
930 # # cant mix cedit plus uci
931 # echo | cedit /etc/config/firewall ||:
932 # uci add_list firewall.@zone[1].network=wg0
933 # uci commit firewall
934 # firewall-cedit ||:
935 # firewall_restart=true
936 # fi
937
938
939
940 cedit /etc/hosts <<EOF ||:
941 127.0.1.1 $hostname
942 EOF
943
944
945 #mail_host=$(grep -F mail.iankelling.org /etc/hosts | awk '{print $1}')
946 # if [[ $mail_host ]]; then
947 # sed -i '/^$mail_host/a mail.iankelling.org' /etc/hosts
948 # fi
949
950
951 uset dhcp.@dnsmasq[0].domain b8.nz
952 uset system.@system[0].hostname $hostname
953 uset dhcp.@dnsmasq[0].local
954
955 # uci doesnt seem to have a way to set an empty value,
956 # if you delete it, it goes back to the default. this seems
957 # to be a decent workaround.
958 # todo: setup /etc/resolv.conf to point to 127.0.0.1
959 # later note: disabled, I dunno why I set this.
960 # uset dhcp.@dnsmasq[0].resolvfile /dev/null
961
962 # if dnsmasq happens to not send out a dns server,
963 # odhcpd will send one out like this:
964 # NetworkManager[953]: <info> [1614982580.5192] dhcp6 (wlan0): option dhcp6_name_servers => 'fd58:5801:8e02::1'
965 # but i dont want ipv6 dns, just keep it simple to ipv4.
966 # I know my isp doesnt have ipv6 right now,
967 # so just stop this thing.
968 # note: tried this, it didn't do anything:
969 # uset dhcp.@odhcpd[0].dns 10.2.0.1
970
971 # iank, disablde while debugging.
972 #/etc/init.d/odhcpd stop
973 #/etc/init.d/odhcpd disable
974
975 # todo: make the above conditional on which server this is.
976
977 ## left commented in case we have ipv6 problems in the future
978 # avoid errors in log. current isp doesnt have ipv6
979 #uset unbound.@unbound[0].protocol ip4_only
980
981 # todo: im not sure all these are needed, but they all look
982 # like good options.
983 # https://blog.cloudflare.com/dns-over-tls-for-openwrt/
984 # https://gist.github.com/vqiu/7b32d3a19a7a09d32e108d998de166c2
985 #https://blog.thestateofme.com/2018/04/04/howto-secure-your-dns-with-a-raspberry-pi-unbound-and-cloudflare-1-1-1-1/
986 #
987 # # i found that the zone example was having no effect on the config
988 # # here:
989 # https://github.com/openwrt/packages/blob/openwrt-19.07/net/unbound/files/README.md
990 #
991 # # todo: unbound-control, i'm not sure what the purpose of that thing is, some
992 # # kind of coordination with dhcp of dnsmasq, but what?
993 #
994 # note: for debugging, edit /etc/init.d/unbound, change
995 # procd_set_param command $PROG -d -c $UB_TOTAL_CONF
996 # to:
997 # procd_set_param command $PROG -vvv -d -c $UB_TOTAL_CONF
998
999 if ! $ap; then
1000 {
1001 cat <<'EOF'
1002 do-tcp: yes
1003 prefetch: yes
1004 qname-minimisation: yes
1005 rrset-roundrobin: yes
1006 use-caps-for-id: yes
1007 do-ip6: yes
1008 private-domain: b8.nz
1009 local-zone: "10.in-addr.arpa." transparent
1010 access-control-view: 10.2.0.31/32 "youtube"
1011 EOF
1012
1013 if $zblock; then
1014 cat <<'EOF'
1015 # no sy until that dongle is used by ziva
1016
1017 # syw
1018 #access-control-view: 10.2.0.7/32 "youtube"
1019 # bow
1020 access-control-view: 10.2.0.29/32 "youtube"
1021 # samsungtab
1022 access-control-view: 10.2.0.32/32 "youtube"
1023 EOF
1024 fi
1025 } | cedit /etc/unbound/unbound_srv.conf || unbound_restart=true
1026
1027
1028 # dns based blocking vs ip based. with ip, same
1029 # server can have multiple domains. in dns,
1030 # you have to make sure clients to use the local dns.
1031 # https dns will need to be blocked by ip in
1032 # order to be comprehensive
1033
1034
1035
1036 {
1037 # shellcheck source=/p/c/ptr-data
1038 . /root/ptr-data
1039 cat <<EOF
1040
1041 local-data-ptr: "10.2.0.1 cmc.b8.nz"
1042
1043 local-data-ptr: "10.174.2.2 transmission.b8.nz"
1044 local-data-ptr: "10.173.8.1 defaultnn.b8.nz"
1045 local-data-ptr: "10.173.8.2 nn.b8.nz"
1046
1047 forward-zone:
1048 name: "."
1049 # forward-addr: 8.8.8.8
1050 # forward-addr: 8.8.8.8
1051
1052 # ssl disabled due to this error:
1053 #Sat Dec 24 03:34:44 2022 daemon.err unbound: [6568:0] error: ssl handshake failed crypto error:1416F086:SSL routines:tls_process_server_certificate:certificate verify failed
1054 #Sat Dec 24 03:34:44 2022 daemon.notice unbound: [6568:0] notice: ssl handshake failed 1.0.0.3 port 853
1055 # on OPENWRT_RELEASE="OpenWrt SNAPSHOT r18639-f5865452ac"
1056 # from about feb 2022
1057
1058 # https://developers.cloudflare.com/1.1.1.1/1.1.1.1-for-families/setup-instructions/dns-over-https
1059 # forward-addr: 1.1.1.3@853#family.cloudflare-dns.com
1060 # forward-addr: 1.0.0.3@853#family.cloudflare-dns.com
1061 # forward-ssl-upstream: yes
1062 forward-first: no
1063 forward-addr: 1.1.1.3
1064 forward-addr: 1.0.0.3
1065
1066 view:
1067 name: "youtube"
1068 local-zone: "googlevideo.com." refuse
1069 local-zone: "video.google.com." refuse
1070 local-zone: "youtu.be." refuse
1071 local-zone: "youtube-nocookie.com." refuse
1072 local-zone: "youtube-ui.l.google.com." refuse
1073 local-zone: "youtube.com." refuse
1074 local-zone: "youtube.googleapis.com." refuse
1075 local-zone: "youtubeeducation.com." refuse
1076 local-zone: "youtubei.googleapis.com." refuse
1077 local-zone: "yt3.ggpht.com." refuse
1078 local-zone: "youtubekids.com." refuse
1079 # try global if no match in view
1080 view-first: yes
1081 EOF
1082 } | cedit /etc/unbound/unbound_ext.conf || unbound_restart=true
1083
1084
1085 if $unbound_restart; then
1086 /etc/init.d/unbound restart
1087 if ! unbound-checkconf; then
1088 echo $0: error: unbound-checkconf failed >&2
1089 exit 1
1090 fi
1091 fi
1092 fi # end if $ap
1093
1094 # # disabled for now. i want to selectively enable it
1095 # # for specific hosts.
1096 # if [[ $(uci get adblock.global.adb_enabled) != 0 ]]; then
1097 # v uci set adblock.global.adb_enabled=0
1098 # uci commit adblock
1099 # /etc/init.d/adblock restart
1100 # fi
1101 # # https://github.com/openwrt/packages/tree/master/net/adblock/files
1102 # cat >/etc/crontabs/root <<'EOF'
1103 # 0 06 * * * /etc/init.d/adblock reload
1104 # EOF
1105
1106
1107 # useful: http://wiki.openwrt.org/doc/howto/dhcp.dnsmasq
1108
1109 # sometimes /mnt/usb fails, cuz it's just a flash drive,
1110 # so make sure we have this dir or else dnsmasq will fail
1111 # to start.
1112 mkdir -p /mnt/usb/tftpboot
1113
1114 {
1115 # generated with host-info-update
1116 # shellcheck source=/p/c/dnsmasq-data
1117 . /root/dnsmasq-data
1118 cat <<EOF
1119 # no dns
1120 port=0
1121 server=/b8.nz/#
1122 ptr-record=1.0.2.10.in-addr.arpa.,cmc.b8.nz
1123
1124
1125 # https://ret2got.wordpress.com/2018/01/19/how-your-ethereum-can-be-stolen-using-dns-rebinding/
1126 stop-dns-rebind
1127 rebind-domain-ok=b8.nz
1128
1129 # This says the ip of dns server.
1130 # It is default if dnsmasq is doing dns, otherwise, we have to specify it.
1131 # To see it in action, I ran this from a client machine:
1132 # sudo dhcpcd -o domain_name_servers -T
1133 dhcp-option=option:dns-server,$l.1
1134
1135 # use this when doing fai to get the right timezone, its nfsroot is
1136 # setup to use this dhcp option only and call ntpdate.
1137 # generate ips with:
1138 # for h in 0.ubuntu.pool.ntp.org 1.ubuntu.pool.ntp.org ntp.ubuntu.com; do host -t a $h | awk '{print $NF}'; done | while read -r l; do printf ,$l; done
1139 dhcp-option=option:ntp-server,188.165.3.28,202.12.97.45,91.236.251.13,50.205.244.23,78.30.254.80,31.131.0.123,202.65.114.202,94.228.220.14,185.125.190.57,185.125.190.58,91.189.91.157,185.125.190.56,91.189.94.4
1140
1141
1142 # results from googling around dnsmasq optimizations
1143 # about 50k in memory. router has 62 megs.
1144 # in a browsing session, I probably won't ever do 5000 lookups
1145 # before the ttl expiration or whatever does expiration.
1146 cache-size=10000
1147
1148 # ask all servers, use the one which responds first.
1149 # http://ma.ttwagner.com/make-dns-fly-with-dnsmasq-all-servers/
1150 all-servers
1151
1152 # namebench benchmarks dns servers. google's dns was only
1153 # slightly less fast than some others, and I trust it more
1154 # to give accurate results, stay relatively fast, and
1155 # not do anythin too malicious, so just use that.
1156 # download namebench and run it like this:
1157 # for x in all regional isp global preferred nearby; do ./namebench.py -s \$x -c US -i firefox -m weighted -J 10 -w; echo \$x; hr; done
1158 # google
1159 server=1.1.1.3
1160 server=1.0.0.3
1161 server=2606:4700:4700::1113
1162 server=2606:4700:4700::1003
1163
1164 server=10.2.0.1
1165 # server=8.8.4.4
1166 # server=8.8.8.8
1167 # server=2001:4860:4860::8888
1168 # server=2001:4860:4860::8844
1169
1170
1171 # to fixup existin ips, on the client you can do
1172 # sudo dhclient -r; sudo dhclient <interface-name>
1173 # or on cmc,
1174 # /etc/init.d/dnsmasq stop
1175 # vi /tmp/dhcp.leases
1176 # /etc/init.d/dnsmasq start
1177
1178
1179 # default dhcp range is 100-150
1180
1181 # template
1182 # dhcp-host=,$l.,
1183
1184 # pxe tftpboot for arch-like. todo: openwrt snapshot from 2022-01, it cant
1185 # access /mnt/usb/tftpboot due to ujail sandbox
1186 #enable-tftp=br-lan
1187 #tftp-root=/mnt/usb/tftpboot
1188 #tftp-root=/var/run/dnsmasq/tftpboot
1189
1190
1191 dhcp-optsfile=/var/run/dnsmasq/dhcpopts.conf
1192
1193 # for debugging dhcp
1194 #log-queries=extra
1195 EOF
1196 } | cedit /etc/dnsmasq.conf || dnsmasq_restart=true
1197
1198
1199
1200 if $dnsmasq_restart && ! $dev2 && ! $ap; then
1201 # todo: can our ptr records be put in /etc/hosts?
1202 # eg: user normal /etc/hosts records, and they wont be used for A resolution
1203 # due to the other settings, but will be used for ptr? then maybe
1204 # we dont have to restart dnsmasq for a dns update?
1205 #
1206 # interesing link:
1207 # https://www.redpill-linpro.com/techblog/2019/08/27/evaluating-local-dnssec-validators.html#toggling-dnssec-validation-1
1208 # we could turn on dnssec validation when wrt gets dnsmasq > 2.80. currently at 2.80.
1209 # also we can turn off dnssec in systemd-resolved if we know the router is doing it.
1210 #
1211 # Also, reload of dnsmasq seems to break things, wifi
1212 # clients were not getting internet connectivity.
1213
1214 v /etc/init.d/dnsmasq restart
1215 fi
1216
1217 if $ap; then
1218 v /etc/init.d/firewall disable
1219 v /etc/init.d/firewall stop
1220 elif $firewall_restart; then
1221 v /etc/init.d/firewall restart
1222 fi
1223
1224 ## turn off luci
1225 # if already stopped, gives error we want to ignore
1226 /etc/init.d/uhttpd stop |& sed '1{/^Command failed/d}'
1227 /etc/init.d/uhttpd disable |& sed '1{/^Command failed/d}'
1228
1229 # this may just restart the network and take care of the network_restart below.
1230 if $wireless_restart; then
1231 v wifi
1232 fi
1233
1234 # todo: we should catch errors and still run this if needed
1235 if $network_restart; then
1236 reboot
1237 fi
1238
1239 v exit 0